%% Example run of S-BSS-vecDC algorithm


if 1
    clear all;
end

display('============= S-BSS-vecDC algorithm =============');

%% data loading
load ./data/phantom_08_5.mat
% provide data matrix D and original source data A_orig and X_orig
[p,n] = size(D);


%% data preprocessing
% removing of zero-activity pixels and images
% scaling using Correspondence analysis (1) or no scaling (0)
scaling = 1;
[scD,kladPix,kladObr,sOn,sOp] = preproc(D,scaling);


%% prior parameters
prior = prior_setting;
r = 4; % expected or maximum number of factors, r_max
iterations = 100; % number of iterations


%% starting data
start = start_data(scD,r);


%% run algorithm
[A_rough,X_rough,U_rough,info] = SBSSvecDC_alg(scD,r,prior,start,iterations);
info.U_rough = U_rough;


%% postprocessing
[A,X,info] = postproc(kladPix,kladObr,scaling,sOn,sOp,p,n,r,A_rough,X_rough,info);


%% print of results
% print images and related TACs - print_type = 1
% print images and related TACs, kernels, and Xi - print_type = 2
print_type = 2; 
print_results(print_type,A,X,info);


%% end
display('done');