function [scD,kladPix,kladObr,sOn,sOp] = preproc(D,scaling)
% function for preprocessing of the data matrix D
% i.e. striking of the zero-activity pixels and images
% and scaling of the data

    if nargin < 2
        scaling = 1;
    end

    % striking of zero-activity pixels and images
        kladPix = find(sum(D,2)>0); % find non-zeros pixels (!=0)
        kladObr = find(sum(D,1)>0); % find non-zeros images (!=0)
        D = D(kladPix,kladObr);
    
    if scaling % scaling of the data
        sOn = 1./sum(D,1)';
        sOp = 1./sum(D,2);
        scD = D.*(sqrt(sOp)*sqrt(sOn)');
    else
        sOn = ones(size(sum(D,1)'));
        sOp = ones(size(sum(D,2)));
        scD = D;
    end
    
end