function print_results(print_type,A,X,info)
% function for print of results of the S-BSS-vecDC algorithm

    [p,r] = size(A);
    [n,r] = size(X);

    max_A = max(A);
    max_A(max_A == 0) = 1;
    ylim_maxX = max(max(X*diag(max_A)));
    ylim_minX = min(min(X*diag(max_A)));
    if ylim_minX > 0
        ylim_minX = 0;
    end


    figure;
    if print_type == 1
        cols = 2;
    elseif print_type == 2
        cols = 4;
    end
    colormap(invgray);

    % selection active parts of images only, full image otherwise
    tisk_zoom = 1; 
    
    i = 1;
    for j=1:r % number of rows
        if (print_type == 2)
            subplot(r,cols,i);
            pomXi = reshape(info.Xi(:,j),sqrt(p),sqrt(p))';
            pomXi(pomXi>0) = 1./pomXi(pomXi>0);
            picture = pomXi;
            if tisk_zoom
                image = find_print_region(picture);
            else
                image = picture;
            end
            imagesc(image);
            set(gca,'YTick',[]); set(gca,'XTick',[]);
            axis('square');
            axis off;
            if (j == 1) && (1)
                title(['\fontsize{14} Pixels Variances']);
            end
            i = i+1;
        end
        if (print_type == 1) || (print_type == 2)
            subplot(r,cols,i);
                if tisk_zoom
                    image = find_print_region(reshape(A(:,j),sqrt(p),sqrt(p))');
                else
                    image = reshape(A(:,j),sqrt(p),sqrt(p))';
                end
                imagesc(image); %,[0 max(max_A)]);
                set(gca,'YTick',[]); set(gca,'XTick',[]);
                axis('square');
                axis off;
            if (j == 1) && (1)
                title(['\fontsize{14} Tissue Images']);
            end
            i = i+1;
        end
        if (print_type == 1) || (print_type == 2)
            subplot(r,cols,i);
                plot(X(:,j)*sum(A(:,j)),'LineWidth',2); hold on;
                ylim([0 1.05*max(max(X.*kron(sum(A),ones(n,1))))]);
                xlim([0 n]);
            if (j == 1) && (1)
                title(['\fontsize{14} Time-activity Curves']);
            end
            hold off;
            i = i+1;
        end
        if (print_type == 2)
            subplot(r,cols,i);
            plot(info.U_rough(:,j));
            ylim([0,1.05*max(info.U_rough(:,j))]);
            xlim([0 n]);
            if (j == 1) && (1)
                title(['\fontsize{14} Convolution Kernels']);
            end
            i = i+1;
        end
    end



end



function [pic2] = find_print_region(pic)
% find active part of the image

    [hx,hy] = find(pic>0);
    low_x = min(hx);
    top_x = max(hx);
    low_y = min(hy);
    top_y = max(hy);
    
    pom = pic(low_x:top_x,low_y:top_y); 
    pic2 = zeros(max(size(pom)));
    
    [sx,sy] = size(pom);
    if sx > sy
        posun = abs(round((sy-sx)/2));
        pic2(:,posun+(1:sy)) = pom;
    else
        posun = abs(round((sy-sx)/2));
        pic2(posun+(1:sx),:) = pom;
    end

end











